<?php

/* 
	Versione	1.2
	Data		13-Novembre-2002
	Autore		Julien Buratto
	Societ?	Linkas Srl
	Change: Aggiunto split automatico se viene passato tutto l'indirizzo,senza http, comprensivo di pagina web
*/
	
/* ESEMPIO D' USO
$prova=new action("www2.linkas.it","/jj/showsubmitted.php");
oppure
$prova=new action("www2.linkas.it/jj/showsubmitted.php","");

$prova->method("POST");
$prova->add("cogname","buratto");
$prova->add("name","julien");
echo($prova->invia());
*/

class action {

var $serv;
var $variabili;
var $method;
var $page;
var $messaggi;
var $debug=false;

function action($server,$page){
	$this->variabili=array();
	$this->method="POST";
	if (!isset($page) or is_null($page) or $page=="") {
	       	$dominio=strtok($server,"/");
		// Suddividi con la barra il dominio dalla pagina col CGI

        	// Dato che strtok si interrompe ogni /, ricrea il sottopercorso
        	while($page=strtok("/")){
                	$pagina.=$page."/";
        	}
		// Togli la barra aggiunta alla fine
        	$pagina=substr($pagina,0,strlen($pagina)-1);
		$pagina=trim($pagina);		
		// Riaggiungi la barra che la strtok ha tolto
        	$pagina="/".$pagina; 
		$this->serv=$dominio;
		$this->page=$pagina;
	} else {
		$this->serv=$server;
		$this->page=$page;
	}
	if (!isset($server) or is_null($server)) exit("La classe deve essere inizializzata con il name del server a cui collegarsi: action(server,pagina)");

}


// Aggiunge una variabile al vettore da trasmettere

function add($name,$value){
	$temp=array();
	array_push($temp,$name);
	array_push($temp,urlencode($value));
	if(array_push($this->variabili,$temp)) {
		return true;
	} else {
		return false;
	}
}

function method($var){
	if ($var!="GET" and $var!="POST") exit("GET o POST");
	$this->method=$var;
}

// Ritorna il testo ottenuto dal webserver remoto o FALSE in caso di insuccesso
function invia() {
        $fp = fsockopen($this->serv,80,$nrerro,$strerr);
	if($this->debug) echo("SERVER APERTO: $this->serv<br>");
	if (!$fp) {
		$this->messaggi=$strerr;
		return false;
	}
        if ($this->method == 'GET') {
		$this->page .= '?' . $this->pack();
	}
	if ($this->debug==true){
		echo("<br>$this->method $this->page HTTP/1.1\n");
        	echo("<br>Host: $this->serv\n");
        	echo("<br>Content-type: application/x-www-form-urlencoded\n");
        	echo("<br>Content-length: " . strlen($this->pack()) . "\n");
	}

        fputs($fp, "$this->method $this->page HTTP/1.1\n");
        fputs($fp, "Host: $this->serv\n");
        fputs($fp, "Content-type: application/x-www-form-urlencoded\n");
        fputs($fp, "Content-length: " . strlen($this->pack()) . "\n");
        // if ($useragent) fputs($fp, "User-Agent: MSIE\n");

        fputs($fp, "Connection: close\n\n");
	if($this->debug) echo("<br>Connection: close\n\n");

        if ($this->method == 'POST'){
		$temp=$this->pack();
	if($this->debug) echo($temp);
                fputs($fp, $temp);
	}

        while (!feof($fp))
                $buf .= fgets($fp,128);
        fclose($fp);
        return $buf;
}

// Toglie una variabile dal vettore da trasmettere
function remove($name){
	if (array_remove($name)) {
		return true;
	} else {
		return false;
	}
}

function setMethod($tipo){
	if ($tipo!="POST" and $tipo!="GET") exit("La classe supporta solo GET e POST e non $tipo");
	if ($method!="POST") $this->method=$tipo;
}

// Restituisce la stringa di query da inviare al server
function pack(){
		for ($i=0;$i<count($this->variabili);$i++){
			$stringa.=$this->variabili[$i][0]."=".$this->variabili[$i][1]."&";
		}
		$stringa=substr($stringa,0,strlen($stringa)-1);
		return $stringa;
}

function serinfo() {
        $fp = fsockopen($this->serv,80,$nrerro,$strerr);
	if($this->debug) echo("SERVER APERTO: $this->serv<br>");
	if (!$fp) {
		$this->messaggi=$strerr;
		return false;
	}
        if ($this->method == 'GET') {
		$this->page .= '?' . $this->pack();
	}
	if ($this->debug==true){
		echo("<br>$this->method $this->page HTTP/1.1\n");
        	echo("<br>Host: $this->serv\n");
        	echo("<br>Content-type: application/x-www-form-urlencoded\n");
        	echo("<br>Content-length: " . strlen($this->pack()) . "\n");
	}

        fputs($fp, "$this->method $this->page HTTP/1.1\n");
        fputs($fp, "Host: $this->serv\n");
        fputs($fp, "Content-type: application/x-www-form-urlencoded\n");
        fputs($fp, "Content-length: " . strlen($this->pack()) . "\n");
        // if ($useragent) fputs($fp, "User-Agent: MSIE\n");

        fputs($fp, "Connection: close\n\n");
	if($this->debug) echo("<br>Connection: close\n\n");

        if ($this->method == 'POST'){
		$temp=$this->pack();
	if($this->debug) echo($temp);
                fputs($fp, $temp);
	}

        while (!feof($fp))
                $buf .= fgets($fp,128);
        fclose($fp);
        return $buf;
}

} // Fine classe