<?php
// 資料庫設定記錄區---------------------------------------------------------------------------------start
class project{
	var $wizard_db="";//儲存資料庫名稱
	var $wizard_table="";//儲存資料表名稱
	var $database="";//查詢-資料表名稱
	var $table="";//查詢-資料表名稱
	var $field="";//查詢-欄位名稱

	//特殊欄位
	
	var $setup =array();
	var $is_file =array();//是否有檔案欄位
	var $is_calendar =array();//是否有日期欄位

	var $indexkey ="";//索引值
	var $kindkey ="";//類別欄位

	var $var_change =array();//var_change 功能

	/****************************
	* 函數功能： 建構函數
	*****************************/
	function project(){
		GLOBAL $wizard_table,$wizard_db;//存在資料-庫、表
		GLOBAL $database,$table,$name;	//查詢資料-庫、表、欄

		$this->wizard_db=$wizard_db;//資料庫名稱
		$this->wizard_table=$wizard_table;//資料表名稱
		
		$this->database=$database;//查詢-資料表名稱
 		$this->table=$table;//查詢-資料表名稱
 		$this->field=$name;//查詢-欄位名稱
		//取得整體設定值
		$this->setup=$this->get_property();
		$this->indexkey=$this->setup["is_where"];
		$this->kindkey=$this->setup["is_kind"];
 		$this->files=$this->setup["file"];//檔案欄位
 		$this->is_calendar=$this->setup["calendar"];//檔案欄位
		//var_dump($this->setup["calendar"]);
		

		//print_r($this->setup);
	} // end func

	/****************************
	* 函數功能： 從資料得到每一欄位的預設值
	* 相關語法： read_project($table,$name)資料表名稱，欄位名稱
	*****************************/
	function read_project(){
		$db =NEW DB; 	
		$db->db=$this->wizard_db; 
		$SQL = "SELECT * FROM $this->wizard_table WHERE  db_name='$this->database' AND table_name='$this->table' AND field_name  ='$this->field'";
		//echo "<hr>";
		$db->query ($SQL);
		$html=array();
		while ($row = $db->fetch_array()) {
				$html['field_name']=$row["field_name"];
				$html['field_caption']=$row["field_caption"];
				$html['is_use']=$row["is_use"];
				$html['is_add']=$row["is_add"];
				$html['is_edit']=$row["is_edit"];
				$html['is_show']=$row["is_show"];
				$html['is_list']=$row["is_list"];
				$html['is_search']=$row["is_search"];
				$html['is_todo']=$row["is_todo"];
				$html['var_change']=$row["var_change"];
				$html['input_type']=$row["input_type"];
				//echo '-';
				$html['field_size']=$row["field_size"];
				$html['maxlen']=$row["maxlen"];
				$html['is_default']=$row["is_default"];
				$html['show_default']=$row["show_default"];
				$html['is_where'] = $row["is_where"];
			} ;
			return $html;
	} // end func

/****************************
* 函數功能： 得到資料表-欄位的設定值
* 相關語法： get_property()資料庫名稱，資料表名稱
*****************************/
function get_property(){
		$db =NEW DB; 	
		$db->db=$this->wizard_db; 
		$SQL = "SELECT * FROM $this->wizard_table WHERE db_name='$this->database' AND table_name='$this->table' AND is_use=1  ORDER BY id ASC";
		$db->query ($SQL);
		while ($row = $db->fetch_array()) {
			$db_name = $row["db_name"];
			$table_name = $row["table_name"];
			$field_name = $row["field_name"];
			$field_caption = $row["field_caption"];
			$is_use = $row["is_use"];
			$is_add = $row["is_add"];
			$is_edit = $row["is_edit"];
			$is_show = $row["is_show"];
			$is_list = $row["is_list"];
			$is_search = $row["is_search"];
			$is_todo = $row["is_todo"];
			$var_change = $row["var_change"];
			$input_type = $row["input_type"];
			$field_size = $row["field_size"];
			$maxlen = $row["maxlen"];
			$is_default = $row["is_default"];
			$show_default = $row["show_default"];

			$is_where = $row["is_where"];
			$is_kind = $row["is_kind"];

		//合成
			$html['field_name'][$row["field_name"]]=$row["field_name"];
			$html['field_caption'][$row["field_name"]]=$row["field_caption"];
			if($row["is_use"]==1){
				$html['is_use'][$row["field_name"]]=$row["field_caption"];
			}
			if($row["is_add"]==1){
				$html['is_add'][$row["field_name"]]=$row["field_caption"];
			}
			if($row["is_edit"]==1){
				$html['is_edit'][$row["field_name"]]=$row["field_caption"];
			}
			if($row["is_show"]==1){
				$html['is_show'][$row["field_name"]]=$row["field_caption"];
			}
			if($row["is_list"]==1){
				$html['is_list'][$row["field_name"]]=$row["field_caption"];
			}
			if($row["is_search"]==1){
				$html['is_search'][$row["field_name"]]=$row["field_caption"];
			}
			if($row["is_todo"]==1){
				$html['is_todo'][$row["field_name"]]=$row["field_caption"];
			}
			$html['var_change'][$row["field_name"]]=$row["var_change"];
			$html['input_type'][$row["field_name"]]=$row["input_type"];
			//得到檔案欄位
			if ($input_type=='file') {
				$html['file'][] = $row["field_name"];		    
			}
			if ($is_where == 1) {
				$html['is_where'] = $row["field_name"];		    
			}
			if ($is_kind == 1) {
			 	$html['is_kind'] = $row["field_name"];		    
			}
		//2005/9/9
			if ($input_type=='calendar') {
				$html['calendar'][] = $row["field_name"];		    
			}
			if ($input_type=='calendar2') {
				$html['calendar2'][] = $row["field_name"];		    
			}

		} ;
	return $html;
} // end func

/****************************
* 函數功能： 將相關設定存入資料庫
* 相關語法： insert_project()
*****************************/
function insert_project(){
	$db =NEW DB; 	
	$db->db=$this->wizard_db; 
	//除舊資料
 	$SQL  = "DELETE FROM $this->wizard_table WHERE table_name='$this->table' AND db_name ='$this->database'";
	$db->query ($SQL);
	for ($x=0;$x<count($_POST["field_name"]); $x++) {
		$field_name = $_POST["field_name"][$x];
		$field_caption = $_POST["field_caption"][$x];
		$is_use = $_POST["is_use"][$x];
		$is_add = $_POST["is_add"][$x];
		$is_edit = $_POST["is_edit"][$x];
		$is_show = $_POST["is_show"][$x];
		$is_list = $_POST["is_list"][$x];
		$is_search = $_POST["is_search"][$x];
		$is_todo = $_POST["is_todo"][$x];
		$var_change = $_POST["var_change"][$x];
		$input_type = $_POST["input_type"][$x];
		$field_size = $_POST["field_size"][$x];
		$maxlen = $_POST["maxlen"][$x];
		$is_default = $_POST["is_default"][$x];
		$show_default = $_POST["show_default"][$x];
 		$num=sprintf('%02d',$x);//兩位自動補0
 		$id=date("YmdHis").$num;
//echo "<br>";
		$SQL = "INSERT INTO $this->wizard_table (id,db_name ,table_name ,field_name ,field_caption ,is_use ,is_add ,is_edit ,is_show ,is_list ,is_search ,is_todo ,var_change ,input_type ,field_size ,maxlen ,is_default ,show_default) values ('$id','$this->database','$this->table','$field_name','$field_caption','$is_use','$is_add','$is_edit','$is_show','$is_list','$is_search','$is_todo','$var_change','$input_type','$field_size','$maxlen','$is_default','$show_default')" ;
	$db->query ($SQL);
	}
	//更新索引欄
	$SQL = "UPDATE $this->wizard_table SET is_where='1' ";
	$SQL .="WHERE db_name='$this->database' AND table_name ='$this->table' AND field_name='$_POST[indexkey]'" ;
	$db->query ($SQL);
	//更新類別欄
	$SQL = "UPDATE $this->wizard_table SET is_kind='1' ";
	$SQL .="WHERE db_name='$this->database' AND table_name ='$this->table' AND field_name='$_POST[kindkey]'" ;
	$db->query ($SQL);

} // end func


/**
 * 取得資料表 pro_name 的相關設檔的中文名稱 
 *
 * Detail description
 * @param      none
 * @global     none
 * @since      1.0
 * @access     private
 * @return     void
 * @update     date time
*/
function get_func_name($db_name,$table_name)
{
    $db =NEW DB; 	
	$db->db=$this->wizard_db; 
	$SQL ="SELECT * FROM pro_name  "; 
    $SQL .="WHERE table_name='$table_name' and db_name ='$db_name'" ; 
    $db->query ($SQL); 
    while ($row = $db->fetch_array()) { 
        $id = $row["id"];
		$db_name = $row["db_name"];
		$table_name = $row["table_name"];
		$func_name = $row["func_name"];
		$file_type = $row["file_type"];
		$file_size = $row["file_size"];

		$pro_name[file_type]=$file_type;
		$pro_name[func_name]=$func_name;
		$pro_name[file_size]=$file_size;
	}
	return $pro_name;

} // end func




/**
 * 更新資料表的中文名稱 
 *
 * Detail description
 * @param      none
 * @global     none
 * @since      1.0
 * @access     private
 * @return     void
 * @update     date time
*/
function update_func_name($db_name,$table_name,$pro_name)
{
	$func_name=		$pro_name[func_name];
	$file_type=		$pro_name[file_type];
	$file_size=		$pro_name[file_size];
    $db =NEW DB; 	
	$db->db=$this->wizard_db; 
	$SQL ="delete FROM pro_name "; 
    $SQL .="WHERE table_name='$table_name' and db_name ='$db_name'" ;
    $db->query ($SQL); 
//指定變數 
    $mk_time =date("Y-m-d H:i:s");
	$id=date("Ymd_His");
    //執行SQL 
    $SQL ="INSERT INTO pro_name ";
	$SQL .="(id,db_name,table_name,func_name,mk_time,file_type,file_size)";
	$SQL .="VALUES ('$id','$db_name','$table_name','$func_name','$mk_time','$file_type','$file_size')";
    $db->query ($SQL); 
	
} // end func

} // end class
?>

