<?php
/**
* 函數功能：   資料-管理權限檢查 
* 相關語法：  AdminCheck()取個人 / 團體檢查
***/
function AdminCheck(){
	$login_level= $_SESSION[SAFEKEY."login_level"];
	if ($login_level > 1) {
	    return true;
	}
	return false;
}

/**
* 函數功能：   資料-管理權限檢查 
* 相關語法：  DataCheck()取個人 / 團體檢查
***/
function DataCheck(){
	$login_level= $_SESSION[SAFEKEY."login_level"];
	$unit_id = $_SESSION[SAFEKEY."unit_id"];
	if($login_level==9) return;
	if($login_level==1) $SQL =" and unit_id ='$unit_id'";
	return $SQL;
}//end func

/**
* 函數功能：pro_check 模組-執行權-檢查
* @param   string $func  模組代碼a
* 相關語法：pro_check($func);
***/
function pro_check($func){
	if (!$func)return;
	$db =NEW DB;
	//模組是否執行檢查
	$SQL ="SELECT * FROM pro_kind WHERE pro_kind_func ='$func' AND pro_islive='1'";
	$db->query ($SQL);
	if (!$db->num_rows()) {
		$errmsg_msg ='目前程式暫停使用喔！';
	    $errmsg_url .="Javascript:history.go(-1)";
		include(HOME_PATH."/errmsg.html");
		exit;
	}
} // end func pro_check()


/**
* 函數功能：  pro_admin 模組-管理-使用權檢查 
* @param  string $func  模組代碼！
* 相關語法：  pro_admin($func);
***/
function pro_admin($func){
	if (!$func) return ;
	$db =NEW DB;
	//模組是否執行檢查
	$SQL ="SELECT * FROM pro_kind WHERE pro_kind_func ='$func' AND pro_islive='1'";
	$db->query ($SQL);
	if (!$db->num_rows()) return false;

	while ($row = $db->fetch_array()) {
		$pro_kind_id = $row["pro_kind_id"];
	}
	
	//模組執行權檢查
	$db2 =NEW DB;
	$SQL2 = "SELECT * FROM pro_check ";
	$SQL2 .=" WHERE login_level IN(".$_SESSION[SAFEKEY."login_level"].") AND pro_kind_id='$pro_kind_id'";
	$db2->query ($SQL2);
	if (!$db2->num_rows()){
		$errmsg_msg ='您無使用權限喔！';
	    $errmsg_url .="Javascript:history.go(-1)";
		include(HOME_PATH."/errmsg.html");
		exit;
	}	
} // end func

/**
* 函數功能: 錯誤回報系統 
* @param  string $str  訊息！
* 相關語法: UserInfo($key ,$mode,$value=0)
***/
function showError($str,$file,$line) {
	echo "<table align=center><tr><td>";
	echo "<li>錯誤訊息:<font color=red>".$str."</font>";
	echo "<li>檔案名稱:<font color=blue>".$file."</font>";
	echo "<li>所在行數:<font color=green>".$line."</font>";
	echo "<li>系統時間:<font color=orange>".date('Y-m-d H:i:s')."</font>";
	echo "</td></tr></table>";
}//end func 
/**
* 函數功能: 傳回網站設定值
* @time  2004-03-26
* @return  array
* 相關語法: web_base()
***/
function web_base(){
	$db =NEW DB;	
	$SQL ="SELECT * FROM web_base WHERE is_use='1' ORDER BY  use_order DESC ";
	$SQL .="LIMIT 0 , 1 ";
	$db->query ($SQL);
	if(!$db->num_rows()){
		 echo "<li>web_base 設定錯誤！請重新設定";
		// exit;
	}


	$setup=array();
	while ($row = $db->fetch_array()) {
		$setup[wb_id] = $row["wb_id"];
		$setup[web_name] = $row["web_name"];
		$setup[web_header] = $row["web_header"];
		$setup[web_footer] = $row["web_footer"];
		$setup[logo] =$row["wb_id"]."/". $row["logo"];
        $setup[bgimg] =$row["wb_id"]."/". $row["bgimg"];
		$setup[css] = $row["css"];
		$setup[bg0] = $row["bg0"];
		$setup[bgt] = $row["bgt"];
		$setup[bg1] = $row["bg1"];
		$setup[bg2] = $row["bg2"];
		$setup[bgw] = $row["bgw"];
		$setup[unit_id] = $row["unit_id"];
		$setup[person_id] = $row["person_id"];
	} 
	//資料處理 
return $setup;
} // end func web_base($num)

/**
* 函數功能: 讀取/寫入session中的帳號名稱//群組代號//權限
* 須配合認證系統作規劃
* @param  string $key   seission名稱
* @param  string $mode  讀取/寫入/全部刪除session
* @param  string $value 寫入值
* 相關語法: 
* UserInfo($key) 得到session值
* UserInfo($mode='r',$key='',$value='') 設定session值
**/
function UserInfo($mode='r',$key='',$value='') {
	//帳號名稱//群組代號//權限-->要調整
	$modes=array("k",'w',"r");
	if (!in_array($mode, $modes)) return 'UserInfo($mode)設定錯誤！';
	if ($mode =='k') {
		session_destroy();
		return;
	}
	$keys=array("uid","gid","lid","level","status");
	if (!in_array($key, $keys)) return 'UserInfo($key)設定錯誤！';

	if ($mode =='w') {
		//設定變數
		switch ($key) {
			case 'uid':
				$_SESSION[SAFEKEY."person_id"]=$value;//個人代號
				return;
				break;
			case 'gid':
				$_SESSION[SAFEKEY."unit_id"]=$value;  //單位代號
				return ;
				break;
			case 'lid':
				$_SESSION[SAFEKEY."login_id"]=$value;//權限代號    
				return ;
				break;
			case 'level':
				$_SESSION[SAFEKEY."login_level"]=$value;//權限代號    
				return ;
				break;
			case 'status':
				$_SESSION[SAFEKEY."login_status"]=$value;//權限代號    
				return ;
				break;
		}//end swich
	}
	if ($mode =='r') {
		//讀取變數
		switch ($key) {
			case 'uid':
				return $_SESSION[SAFEKEY."person_id"];//個人代號
				break;
			case 'gid':
				return $_SESSION[SAFEKEY."unit_id"];  //單位代號
				break;
			case 'lid':
				return $_SESSION[SAFEKEY."login_id"];//權限代號    
				break;
			case 'level':
				return $_SESSION[SAFEKEY."login_level"];//權限代號    
				break;
			case 'status':
				return $_SESSION[SAFEKEY."login_status"];//權限代號    
				break;

		}//end swich
	}
}//end func

/**
* 函數功能：  FormKindObj 模組-類別 表單選取物件 
* 相關語法：  FormKindObj(表單物件名稱,預設值,模組名稱,表單物件形態,每列幾個);
* FormKindObj("result_future",$result_future,$this->func,"radiobox",4)
* FormKindObj("rf_kind",$rf_kind,$this->func,"radiobox",4);
***/
function FormKindObj($name,$default,$kind,$type='radiobox',$objnum=4){
	$db= new DB;
     $SQL ="SELECT * FROM item WHERE kind ='$kind' ORDER BY item_order ASC";
	$db->query ($SQL);
	$i=0;
	while ($row = $db->fetch_array()) {
		$id = $row["id"];
		$prgid = $row["prgid"];
		$kind = $row["kind"];
		$item_name = $row["item_name"];
		$item_alias = $row["item_alias"];
		$ids[]=$item_name;
		$names[]=$item_alias;	
	}
	
	//以ids作為陣列代表
	if ($ids == "" OR $names =="")return "-1 Func_FormKindObj()";
	//預設值
	if ($default == "" and $type !="checkbox") {
		$default = $ids[0];
	}
	//取出秀出值
	for ($i =0;$i<count($ids) ; $i++) {
	    if ($ids[$i] == $default) {
	        $show = $names[$i];
	    }
	}
	//print_r($names);print_r($ids);print_r($ids)
	$tools=NEW TOOLS;//工具函數庫
	switch ($type) {
	    case "selbox":
			$obj=$tools->mk_select($name,$ids,$names,$default);
			break;
 	    case "radiobox":
			$obj=$tools->mk_radio($name,$ids,$names,$default,$objnum);
			break;
 	    case "checkbox":
			$obj=$tools->mk_checkbox($name,$ids,$names,$default,$objnum);
			break;
 	    case "show":
			$obj=$show;
			break;
	}
	return $obj;    
} // end FormKindObj

/*******************
* 函數功能：  Get_Person_Name 查出人員姓名 
* 相關語法：  Get_Person_Name($id)
********************/
function Get_Person_Name($person_id){
	$db =NEW DB;
	$SQL ="SELECT * FROM person  WHERE person_id  = '$person_id'" ;
	$db->query ($SQL);
	$num=$db->num_rows();
	if ($num !=1) RETURN "-1";
	while ($row = $db->fetch_array()){
		$name = $row["name"];
	};	
	return $name;    
} // end func

/*******************
* 函數功能：  Get_Uint_Name 查出單位名稱 
* 相關語法：  Get_Uint_Name($id)
********************/
function Get_Unit_Name($unit_id){
	$db =NEW DB;
 	$SQL ="SELECT unit_name FROM unit WHERE unit_id ='$unit_id'" ;
	$db->query ($SQL);
	$num=$db->num_rows();
	if ($num !=1) RETURN "-1";
	while ($row = $db->fetch_array()){
		 $name = $row["unit_name"];
	};	
	return $name;    
} // end func

/**
* 函數功能：  Unit_FormObj 單位項目選取物件 
* 相關語法：  Unit_FormObj($name,$type,$id);
***/
function Unit_FormObj($objname,$type,$default,$mode=0,$objnum=4){
	$db =NEW DB;  
	$SQL ="SELECT * FROM unit_basic ";
	switch ($mode) {
	    case 1:
			$SQL .= " WHERE unit_kind  ='A1'";
			break;
	    case 2:
			$SQL .= " WHERE unit_kind  !='A1'";
			break;
	    default:
			$SQL .= "";
	}
	$SQL .= " ORDER BY unit_id";

	$db->query ($SQL);
	$num=$db->num_rows();
	$i=0;
	while ($row = $db->fetch_array()){
		$i++;
    	$unit_id = $row["unit_id"];
		$name = $row["name"];
		$county = ($row["county"])?"[".$row["county"]."]":"";
		$ids[] = $row["unit_id"];

		$names[] =$i.".$county-".$row["name"];
	};	
	if ($default ==""  and $type !="checkbox") {
		$default =$ids[0];
	}
	$tools=NEW TOOLS;//工具函數庫
	switch ($type) {
	    case 'selbox':
			$obj=$tools->mk_select($objname,$ids,$names,$default);
			break;
 	    case 
			'radiobox':
			$obj=$tools->mk_radio($objname,$ids,$names,$default,$objnum);
			break;
 	    case 'checkbox':
			$obj=$tools->mk_checkbox($objname,$ids,$names,$default,$objnum);
			break;
 	}
	return $obj;    
} // end func
/**
* 函數功能：  Pro_kind_FormObj 模組名稱選取物件 
* 相關語法：  Pro_kind_FormObj($name,$type,$default,$objnum=4);
***/
function Pro_kind_FormObj($objname,$type,$default,$objnum=4){
	$db =NEW DB;    
	$SQL ="SELECT * FROM pro_kind ORDER BY pro_kind_id" ;
	$db->query ($SQL);
	$num=$db->num_rows();
	$i=0;
	while ($row = $db->fetch_array()){
		$i++;
		$ids[] = $row["pro_kind_id"];
		$names[] =$row["pro_kind_id"].".".$row["pro_kind_name"];
	};	
	if ($default =="") {
		$default =$ids[0];
	}
	$tools=NEW TOOLS;//工具函數庫
	switch ($type) {
	    case 'selbox':
			$obj=$tools->mk_select($objname,$ids,$names,$id);
			break;
 	    case 'radiobox':
			$obj=$tools->mk_radio($objname,$ids,$names,$default,$objnum);
			break;
 	    case 'checkbox':
			$obj=$tools->mk_checkbox($objname,$ids,$names,$default,$objnum);
			break;
	}
	return $obj;    
} // end func
/**
* 函數功能：  Get_Pro_kind_Name 查出模組名稱 
* 相關語法：  Get_Pro_kind_Name($id)
***/
function Get_Pro_kind_Name($default){
	$db =NEW DB;
	if ($default =="")return false;
	$SQL ="SELECT * FROM pro_kind  WHERE pro_kind_id  = '$default' ORDER BY pro_kind_id" ;
	$db->query ($SQL);
	$num=$db->num_rows();
	if ($num !=1) RETURN "查無此資料！";
	while ($row = $db->fetch_array()){
	$name = $row["pro_kind_name"];
	};	
	return $name;    
} // end func

/***************************
* 函數功能: 除錯回報系
* @param  string $str  訊息！
* 相關語法: showError($key ,$mode,$value=0)
****************************/
function debug() {
	if (DEBUG !=1)return ;

	$color="#0066FF";
	$color2="#FF0000";
	$color3="#F900F9";

	//$ss = "<li onclick=\"_a1.style.display = (_a1.style.display=='block')?'none':'block'\"><font color=red>除錯導覽列-debug--start</font></li>";
//	$ss .= "--維持<input type=checkbox value=1>";
	$ss .= " <li>_POST: ";



	if (count($_POST)>0) {
		$ss .=print_r($_POST,1);
	}
	$ss .= "<li>_GET: ";
	if (count($_GET)>0) {
		$ss .=print_r($_GET,1);
	}
	$ss .= "<li>_SESSION: ";
	if (count($_SESSION)>0) {
		$ss .=print_r($_SESSION,1);
	}
	/*$ss .= "<li>_COOKIE: ";
	if (count($_COOKIE)>0) {
		$ss .=print_r($_COOKIE,1);
	}*/
	$ss .= "<li>SCRIPT:<font color=$color3>$script</font> ";
	//$patterns[0] = '/(_GET|_COOKIE|_POST|_SCRIPT|_SESSION|SCRIPT|Array)/';
	$patterns[0] = '/(_GET|_COOKIE|_POST|_SCRIPT|_SESSION|SCRIPT|Array)/';
	$patterns[1] = '/\[([a-zA-Z_\.]+)\] => ([a-zA-Z0-9_\-.]+)/';


	$replacements[0] = "<b><font color=$color>\\1</font></b>";
	$replacements[1] = "[<font color=$color2>\\1</font>] => <font color=$color3>\\2</font>";

	$included_files = get_included_files();
	$ss2 = "<li><b><font color=$color>Included_Files:</font></b>";
		$home_path=HOME_PATH;
		$home_path=str_replace('/','\\',$home_path);

	foreach ($included_files as $filename) {
		$filename=str_replace($home_path,'',$filename);
		if (eregi(".html$",$filename)) {
			$ss2 .= "<br><font color=$color> $filename </font>";
		}elseif (eregi("obj_",$filename)) {
			$ss2 .= "<br><font color=$color2>◎=> $filename </font>";
		}else {
			$ss2 .= "<br> $filename\n";
		    
		}
	}
	//$ss .= "</span>";
	//$ss .= "<li onclick=\"_a1.style.display = (_a1.style.display=='block')?'none':'block'\"><font color=red>除錯導覽列-debug--end</font></li>";



		$ss =  preg_replace($patterns, $replacements, $ss);
		include('debug.html');
	//echo $ss;
}//end func 
/**
 * 產生相關檔案說明
 *
 * Detail description
 * @param      array()可以上傳的檔案格式
 * @param      str 檔案的大小
 * @update     2005/10/5
*/
function file_comment($allow_files,$file_size)
{
	$str ="支援格式:";
     foreach ($allow_files as $file) {
	 	if (is_file(IMAGE_PATH."icon/$file".".gif")) {
				$str .= "<img src=".IMAGE_URL."icon/$file".".gif border='0' alt='$file'>";
			}
		 }
	 $str .="大小限制:<font color='red'>$file_size </font>KB ";
	 return $str;

} // end func
/**
 * Short description. 
 *
 * Detail description
 * @param      none
 * @global     none
 * @since      1.0
 * @access     private
 * @return     void
 * @update     date time

function useFckeditor($name,$value,$height=300,$width='100%')
{

	//echo HOME_PATH;
	//fckeditor的絕對路徑
    include(HOME_PATH."html/FCKeditor/fckeditor.php") ;
	$oFCKeditor = new FCKeditor($name) ;
	//fckeditor的 URL
	$oFCKeditor->BasePath = WEBURL.'FCKeditor/';
	$oFCKeditor->Height = $height ;
	$oFCKeditor->Width  = $width ;
//	$oFCKeditor->ToolbarSet	= 'Basic' ;

	//$value=stripslashes($value);
	$oFCKeditor->Value = $value;
	$oFCKeditor->Create() ;

} // end func
*/
/**
 * 從資料表中取出資料變成表單元件. 
 *
 * Detail description
 * @param      $table string 資料表名稱
 * @param      $table_id string 欄位名稱-編號
 * @param      $table_item string 欄位名稱-值
 * @param      $name string 表單元件名稱
 * @param      $default string 表單元件預設值
 * @param      $type string 表單元件-形態
 * @param      $limit string 表單元件-幾個排成一列
 * @global     none
 * @since      1.0
 * @access     private
 * @return     void
 * @update     2006/2/4
  example: echo TableKindObj("law","law_id ","law_name","person_obj",$default,"checkbox",4);

*/
function TableKindObj($table,$table_id,$table_item,$name,$default,$type,$limit){
	$db= new DB;
	$tools = new TOOLS;
    $SQL ="SELECT * FROM $table ";
	$db->query ($SQL);
	$i=0;
	while ($row = $db->fetch_array()) {
		$id = $row[$table_id];
		$item = $row[$table_item];
		$ids[]=$id;
		$names[]=$item;
		if ($id ==$default) {
		    $show=$item;
		}
	}
	switch ($type) {
	    case "selbox":
			if(!$default)$default =$ids[0];//預設值
			$obj=$tools->mk_select($name,$ids,$names,$default);
			break;
 	    case "radiobox":
			if(!$default)$default =$ids[0];	//預設值
			$obj=$tools->mk_radio($name,$ids,$names,$default,$limit);
			break;
 	    case "checkbox":
			 $obj=$tools->mk_checkbox($name,$ids,$names,$default,$limit);
			break;
 	    case "show":
			$obj=$show;
			break;
 	    case "var":
			$obj=$_array;
	}
	return $obj;  
	}//end func

	/**
	 * Short 產生時間的選擇-表單元件. 
	 *
	 * Detail description
	 * @param      string $name  元件名稱
	 * @param      string $time  時間格式hh:mm
	 * @global     none
	 * @since      1.0
	 * @access     private
	 * @return     void
	 * @update     date time
	*/
	function timeSelectBox($name,$time)
	{
		list($hh_default,$mm_default,$ss_default)=split(":",$time);
		$hh_obj=$name."_hour";
		$mm_obj=$name."_minute";

		$str ="<input type='hidden' name='$name' value='$time'>";	
		$str .=" <select name='$hh_obj' size='1' onChange=\"		document.all.$name.value=document.all.$hh_obj.options[document.all.$hh_obj.selectedIndex].value+':'+document.all.$mm_obj.options[document.all.$mm_obj.selectedIndex].value;
		 \">";
		for ($i=0;$i<=23 ;$i++ ) {
		    $hh=sprintf('%02d',$i);
			$str .=" <option value='$hh'";
			if ($hh_default==$hh) {
			    $str .="selected>";
			}else {
			    $str .=">";
			}
		    $str .="$hh</option>";
		 }
		    $str .="</select>";

		$str2 .=" <select name='$mm_obj' size='1' onChange=\"		document.all.$name.value=document.all.$hh_obj.options[document.all.$hh_obj.selectedIndex].value+':'+document.all.$mm_obj.options[document.all.$mm_obj.selectedIndex].value;
		 \">";
		for ($i=0;$i<=59 ;$i++ ) {
		    $mm=sprintf('%02d',$i);
			$str2 .=" <option value='$mm'";
			if ($mm_default==$mm) {
			    $str2 .="selected>";
			}else {
			    $str2 .=">";
			}
		    $str2 .="$mm</option>";
		 }
	    $str2 .="</select>";

return	$all_str="$str 小時 $str2 分";
	    
	} // end func

	 	/**
	 * Short 產生年月日的選擇-表單元件. 
	 *
	 * Detail description
	 * @param      string $name  元件名稱
	 * @param      string $date   日期 西元
	 * @param      string $type   ad->西元 tw->民國
	 * @param      string $obj_type   欄位格式 0->hidden,1->text
	 * @global     none
	 * @since      1.0
	 * @access     private
	 * @return     void
	 * @update     date time
	*/
	function dateSelectBox($name,$date,$type='ad',$obj_type=0)
	{
		list($yy_default,$mm_default,$dd_default)=split("-",$date);
		$yy_obj=$name."_yy";
		$mm_obj=$name."_mm";
		$dd_obj=$name."_dd";

		$obj_type=($obj_type==0)?"hidden":"text";

		$str ="<input type='$obj_type' name='$name' value='$date' size=12>";	
		$str1 .=" <select name='$yy_obj' size='1' onChange=\"		document.all.$name.value=document.all.$yy_obj.options[document.all.$yy_obj.selectedIndex].value+		'-'+document.all.$mm_obj.options[document.all.$mm_obj.selectedIndex].value+		'-'+document.all.$dd_obj.options[document.all.$dd_obj.selectedIndex].value
		 \">";
		$year=date('Y');
		for ($i=$year;$i>1911 ;$i-- ) {
		    $hh=sprintf('%02d',$i);
			$str1 .=" <option value='$hh'";
			if ($yy_default==$hh) {
			    $str1 .="selected>";
			}else {
			    $str1 .=">";
			}
			if ($type=='tw') {
			    $hh=$i-1911;
				$hh=sprintf('%02d',$hh);

			}

		    $str1 .="$hh</option>";
		 }
		    $str1 .="</select>";

		$str2 .=" <select name='$mm_obj' size='1' onChange=\"		document.all.$name.value=document.all.$yy_obj.options[document.all.$yy_obj.selectedIndex].value+		'-'+document.all.$mm_obj.options[document.all.$mm_obj.selectedIndex].value+		'-'+document.all.$dd_obj.options[document.all.$dd_obj.selectedIndex].value
		 \">";
		for ($i=1;$i<=12 ;$i++ ) {
		    $mm=sprintf('%02d',$i);
			$str2 .=" <option value='$mm'";
			if ($mm_default==$mm) {
			    $str2 .="selected>";
			}else {
			    $str2 .=">";
			}
		    $str2 .="$mm</option>";
		 }
	    $str2 .="</select>";

		$str3 .=" <select name='$dd_obj' size='1' onChange=\"		document.all.$name.value=document.all.$yy_obj.options[document.all.$yy_obj.selectedIndex].value+		'-'+document.all.$mm_obj.options[document.all.$mm_obj.selectedIndex].value+	'-'+document.all.$dd_obj.options[document.all.$dd_obj.selectedIndex].value
		 \">";
		for ($i=1;$i<=31;$i++ ) {
		    $dd=sprintf('%02d',$i);
			$str3 .=" <option value='$dd'";
			if ($dd_default==$dd) {
			    $str3 .="selected>";
			}else {
			    $str3 .=">";
			}
		    $str3 .="$dd</option>";
		 }
	    $str3 .="</select>";
		if ($type == 'tw'){
			$all_str="$str 民國 $str1 年 $str2 月 $str3 日";
		}else {
		    $all_str="$str 西元 $str1 年 $str2 月 $str3 日";
		}

return	$all_str;
	    
	} // end func

	 	/**
	 * Short 產生年月日的選擇-表單元件. -從今年開始五年內
	 *
	 * Detail description
	 * @param      string $name  元件名稱
	 * @param      string $date   日期 西元
	 * @param      string $type   ad->西元 tw->民國
	 * @param      string $obj_type   欄位格式 0->hidden,1->text
	 * @global     none
	 * @since      1.0
	 * @access     private
	 * @return     void
	 * @update     date time
	*/
	function dateSelectBox2($name,$date,$type='ad',$obj_type=0)
	{
		list($yy_default,$mm_default,$dd_default)=split("-",$date);
		$yy_obj=$name."_yy";
		$mm_obj=$name."_mm";
		$dd_obj=$name."_dd";

		$obj_type=($obj_type==0)?"hidden":"text";

		$str ="<input type='$obj_type' name='$name' value='$date' size=12>";	
		$str1 .=" <select name='$yy_obj' size='1' onChange=\"		document.all.$name.value=document.all.$yy_obj.options[document.all.$yy_obj.selectedIndex].value+		'-'+document.all.$mm_obj.options[document.all.$mm_obj.selectedIndex].value+		'-'+document.all.$dd_obj.options[document.all.$dd_obj.selectedIndex].value
		 \">";
		$year=date('Y');
		for ($i=$year;$i<$year+5 ;$i++ ) {
		    $hh=sprintf('%02d',$i);
			$str1 .=" <option value='$hh'";
			if ($yy_default==$hh) {
			    $str1 .="selected>";
			}else {
			    $str1 .=">";
			}
			if ($type=='tw') {
			    $hh=$i-1911;
				$hh=sprintf('%02d',$hh);

			}

		    $str1 .="$hh</option>";
		 }
		    $str1 .="</select>";

		$str2 .=" <select name='$mm_obj' size='1' onChange=\"		document.all.$name.value=document.all.$yy_obj.options[document.all.$yy_obj.selectedIndex].value+		'-'+document.all.$mm_obj.options[document.all.$mm_obj.selectedIndex].value+		'-'+document.all.$dd_obj.options[document.all.$dd_obj.selectedIndex].value
		 \">";
		for ($i=1;$i<=12 ;$i++ ) {
		    $mm=sprintf('%02d',$i);
			$str2 .=" <option value='$mm'";
			if ($mm_default==$mm) {
			    $str2 .="selected>";
			}else {
			    $str2 .=">";
			}
		    $str2 .="$mm</option>";
		 }
	    $str2 .="</select>";

		$str3 .=" <select name='$dd_obj' size='1' onChange=\"		document.all.$name.value=document.all.$yy_obj.options[document.all.$yy_obj.selectedIndex].value+		'-'+document.all.$mm_obj.options[document.all.$mm_obj.selectedIndex].value+	'-'+document.all.$dd_obj.options[document.all.$dd_obj.selectedIndex].value
		 \">";
		for ($i=1;$i<=31;$i++ ) {
		    $dd=sprintf('%02d',$i);
			$str3 .=" <option value='$dd'";
			if ($dd_default==$dd) {
			    $str3 .="selected>";
			}else {
			    $str3 .=">";
			}
		    $str3 .="$dd</option>";
		 }
	    $str3 .="</select>";
		if ($type == 'tw'){
			$all_str="$str 民國 $str1 年 $str2 月 $str3 日";
		}else {
		    $all_str="$str 西元 $str1 年 $str2 月 $str3 日";
		}

return	$all_str;
	    
	} // end func
///去除HTML標籤

Function HTML_2_TEXT($Document){
   Return Ereg_Replace('<([^>]|\n)*>', '',$Document);	  
}
///輸入網址自動轉成連結
Function HTML_2_Link($String){
	return $String = Ereg_Replace("((http[s]?)|(ftp)|(telnet)|(gopher))+://[^<>[:space:]]+[[:alnum:]/]","<a href=\"\\0\" target=_blank>\\0</a>", $String);

}
/****************************
* 函數功能: 縣市選擇物件
* 相關語法: addressBox()
addressBox('county','zone','zip','county',$county_value,$zone_value); 
addressBox('county','zone','zip','zone',$county_value,$zone_value) ;
addressBox('county','zone','zip','ini',$county_value,$zone_value) ;


*****************************/
function addressBox($county_name,$zone_name,$zip_name,$obj_type,$county_value,$zone_value) {
$url=WEBURL;
	switch($obj_type) {
		case 'county':
			$str ="
			<select name=\"$county_name\" onChange=\"changeZone(document.all.$county_name, document.all.$zone_name, document.all.$zip_name)\" size=\"1\">
			</select>
			";
			break;
		case 'zone':
			$str ="
			<select name=zone
			   onChange=\"showZipCode(document.all.$county_name, document.all.$zone_name, document.all.$zip_name)\" 
			size=1>
			</select>";
		break;
		case 'ini':
			$str = "
			<script language='javascript' src='${url}js/address.js'></script> 
			<script language='javascript'>
			initCounty2(document.all.$county_name,'$county_value')
			initZone2(document.all.$county_name, document.all.$zone_name, document.all.$zip_name,'$zone_value');
			</script>
			"; 	
		break;

	}
	Return $str;
}//end func
?>
